您的位置:首页 > 其它

Codeforces Round #143 (Div. 2) C. To Add or Not to Add —— 二分

2017-04-14 23:07 369 查看
题目链接:http://codeforces.com/problemset/problem/231/C

C. To Add or Not to Add

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

A piece of paper contains an array of n integers a1, a2, ..., an.
Your task is to find a number that occurs the maximum number of times in this array.

However, before looking for such number, you are allowed to perform not more than k following operations — choose an arbitrary element
from the array and add 1 to it. In other words, you are allowed to increase some array element by 1 no
more than k times (you are allowed to increase the same element of the array multiple times).

Your task is to find the maximum number of occurrences of some number in the array after performing no more than k allowed operations.
If there are several such numbers, your task is to find the minimum one.

Input

The first line contains two integers n and k (1 ≤ n ≤ 105; 0 ≤ k ≤ 109)
— the number of elements in the array and the number of operations you are allowed to perform, correspondingly.

The third line contains a sequence of n integers a1, a2, ..., an (|ai| ≤ 109) —
the initial array. The numbers in the lines are separated by single spaces.

Output

In a single line print two numbers — the maximum number of occurrences of some number in the array after at most k allowed operations
are performed, and the minimum number that reaches the given maximum. Separate the printed numbers by whitespaces.

Examples

input
5 3
6 3 4 0 2


output
3 4


input
3 45 5 5


output
3 5


input
5 3
3 1 2 2 1


output
4 2


Note

In the first sample your task is to increase the second element of the array once and increase the fifth element of the array twice. Thus, we get sequence 6, 4, 4, 0, 4,
where number 4 occurs 3 times.

In the second sample you don't need to perform a single operation or increase each element by one. If we do nothing, we get array 5, 5, 5, if
we increase each by one, we get 6, 6, 6. In both cases the maximum number of occurrences equals 3.
So we should do nothing, as number 5 is less than number 6.

In the third sample we should increase the second array element once and the fifth element once. Thus, we get sequence 3, 2, 2, 2, 2, where
number 2 occurs 4 times.

题解:

n:1~100000,由于数据量大 ,用O(n^2)的方法肯定超时,那么就考虑用O(nlogn),看到logn,自然想到二分。于是就用二分法。logn为二分个数,n为枚举答案值。所以就是nlogn了。(如果二分 答案值,则不能判断当前答案值是否合法来缩小范围) 注意用前缀和来优化(否则也不能降到nlogn的复杂度)。

写法一:

#include<iostream>//先二分个数,后枚举答案判断是否合法,逐步逼近。
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<algorithm>
#include<cmath>
#include<queue>
#include<vector>
#include<map>
#include<string>
#include<set>
#define LL long long
#define MAX(a,b) (a>b?a:b)
#define MIN(a,b) (a<b?a:b)
#define INF 0x7fffffff
#define LNF ((1LL<<62)-1)
#define maxn 200010

using namespace std;

LL a[100005], sum[100005];
LL n, k,m,cnt,val;

int test(int tmp)
{
for(int i = tmp; i<=n; i++)
{
if(sum[i]-sum[i-tmp]+k>=tmp*a[i])
{
cnt = tmp;
val = a[i];
return 1;
}
}
return 0;
}

int main()
{
cin>>n>>k;
for(int i = 1; i<=n; i++)
scanf("%lld",&a[i]);

sort(a+1,a+1+n);
for(int i = 1; i<=n; i++)
sum[i] = sum[i-1] + a[i];

int h = 1, t = n, mid;
while(h<=t)
{
mid = (h+t)/2;
if(test(mid))
h = mid + 1;
else
t = mid - 1;
}

cout<<cnt<<' '<<val<<endl;
}


写法二:

#include<iostream>//先枚举答案,后二分个数(更新最小的合法个数)
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<algorithm>
#include<cmath>
#include<queue>
#include<vector>
#include<map>
#include<string>
#include<set>
#define LL long long
#define MAX(a,b) (a>b?a:b)
#define MIN(a,b) (a<b?a:b)
#define INF 0x7fffffff
#define LNF ((1LL<<62)-1)
#define maxn 200010

using namespace std;

LL a[100005], sum[100005];
LL n, k,m,ans1 = -1,ans2 = -1;

void binsch(int pos)
{
int h = 0, t = pos-1, mid,cnt;
while(h<=t)
{
mid = (h+t)/2;
cnt = pos - mid;
if(a[pos]*cnt<=sum[pos]-sum[mid]+k)
{
if(cnt>ans1)//更新答案
{
ans1 = cnt;
ans2 = a[pos];
}
t = mid-1;
}
else h = mid+1;
}
}

int main()
{
cin>>n>>k;
for(int i = 1; i<=n; i++)
scanf("%lld",&a[i]);
sort(a+1,a+1+n);

for(int i = 1; i<=n; i++)
sum[i] = sum[i-1] + a[i];

for(int i = 1; i<=n; i++)
binsch(i);

cout<<ans1<<' '<<ans2<<endl;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: 
相关文章推荐